This patchset adds a stress test for kprobes and a test for checking
optimized probes.
The two tests are being added based on the below discussion:
https://lore.kernel.org/all/[email protected]/
Changelog:
* Add an explicit fork after enabling the events ( echo "forked" )
* Remove the extended test from multiple_kprobe_types.tc which adds
multiple consecutive probes in a function and add it as a
separate test case.
* Add new test case which checks for optimized probes.
Akanksha J N (2):
selftests/ftrace: Add new test case which adds multiple consecutive
probes in a function
selftests/ftrace: Add new test case which checks for optimized probes
.../test.d/kprobe/kprobe_insn_boundary.tc | 19 +++++++++++
.../ftrace/test.d/kprobe/kprobe_opt_types.tc | 34 +++++++++++++++++++
2 files changed, 53 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_opt_types.tc
--
2.31.1
Commit 97f88a3d723162 ("powerpc/kprobes: Fix null pointer reference in
arch_prepare_kprobe()") fixed a recent kernel oops that was caused as
ftrace-based kprobe does not generate kprobe::ainsn::insn and it gets
set to NULL.
Add new test case kprobe_insn_boundary.tc which adds a
kprobe at every byte within $FUNCTION_FORK up to an offset of 256 bytes,
to be able to test potential issues with kprobes on
successive instructions.
The '|| continue' is added with the echo statement to ignore errors that
are caused by trying to add kprobes to non probeable lines and continue
with the test.
Signed-off-by: Akanksha J N <[email protected]>
---
.../test.d/kprobe/kprobe_insn_boundary.tc | 19 +++++++++++++++++++
1 file changed, 19 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
new file mode 100644
index 000000000000..4f7cc318f331
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
@@ -0,0 +1,19 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Copyright (C) 2023 Akanksha J N, IBM corporation
+# description: Register multiple kprobe events in a function
+# requires: kprobe_events
+
+for i in `seq 0 255`; do
+ echo p $FUNCTION_FORK+${i} >> kprobe_events || continue
+done
+
+cat kprobe_events >> $testlog
+
+echo 1 > events/kprobes/enable
+( echo "forked" )
+echo 0 > events/kprobes/enable
+echo > kprobe_events
+echo "Waiting for unoptimizing & freeing"
+sleep 5
+echo "Done"
--
2.31.1
Akanksha J N wrote:
> This patchset adds a stress test for kprobes and a test for checking
> optimized probes.
> The two tests are being added based on the below discussion:
> https://lore.kernel.org/all/[email protected]/
>
> Changelog:
>
>
> * Add an explicit fork after enabling the events ( echo "forked" )
> * Remove the extended test from multiple_kprobe_types.tc which adds
> multiple consecutive probes in a function and add it as a
> separate test case.
> * Add new test case which checks for optimized probes.
>
> Akanksha J N (2):
> selftests/ftrace: Add new test case which adds multiple consecutive
> probes in a function
> selftests/ftrace: Add new test case which checks for optimized probes
>
> .../test.d/kprobe/kprobe_insn_boundary.tc | 19 +++++++++++
> .../ftrace/test.d/kprobe/kprobe_opt_types.tc | 34 +++++++++++++++++++
> 2 files changed, 53 insertions(+)
> create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
> create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_opt_types.tc
This series looks good to me.
Acked-by: Naveen N. Rao <[email protected]>
- Naveen
On Tue, 18 Apr 2023 15:25:56 +0530
Akanksha J N <[email protected]> wrote:
> Commit 97f88a3d723162 ("powerpc/kprobes: Fix null pointer reference in
> arch_prepare_kprobe()") fixed a recent kernel oops that was caused as
> ftrace-based kprobe does not generate kprobe::ainsn::insn and it gets
> set to NULL.
> Add new test case kprobe_insn_boundary.tc which adds a
> kprobe at every byte within $FUNCTION_FORK up to an offset of 256 bytes,
> to be able to test potential issues with kprobes on
> successive instructions.
> The '|| continue' is added with the echo statement to ignore errors that
> are caused by trying to add kprobes to non probeable lines and continue
> with the test.
Hi Akanksha,
Thanks for adding test case. This looks good to me.
Acked-by: Masami Hiramatsu (Google) <[email protected]>
> Signed-off-by: Akanksha J N <[email protected]>
> ---
> .../test.d/kprobe/kprobe_insn_boundary.tc | 19 +++++++++++++++++++
> 1 file changed, 19 insertions(+)
> create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
>
> diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
> new file mode 100644
> index 000000000000..4f7cc318f331
> --- /dev/null
> +++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_insn_boundary.tc
> @@ -0,0 +1,19 @@
> +#!/bin/sh
> +# SPDX-License-Identifier: GPL-2.0-or-later
> +# Copyright (C) 2023 Akanksha J N, IBM corporation
> +# description: Register multiple kprobe events in a function
> +# requires: kprobe_events
> +
> +for i in `seq 0 255`; do
> + echo p $FUNCTION_FORK+${i} >> kprobe_events || continue
> +done
> +
> +cat kprobe_events >> $testlog
> +
> +echo 1 > events/kprobes/enable
> +( echo "forked" )
> +echo 0 > events/kprobes/enable
> +echo > kprobe_events
> +echo "Waiting for unoptimizing & freeing"
> +sleep 5
> +echo "Done"
> --
> 2.31.1
>
--
Masami Hiramatsu (Google) <[email protected]>